
CompAction __StartReg(v: byte) begin
 0xB0, v
end

CompAction __StopReg begin
 0xB1 
end

CompAction __SetTemp(v: int) begin
 0xB3, v
end

CompAction __SetRisTemp(v: int, z:word) begin
 0xB4, v, z 
end

CompAction __SetRegulator(v: byte, z:byte) begin
 0xB7, v, z 
end

CompAction __TR_Gain_correction (v: byte,u:int) begin
 0xB8, v, u
end

CompAction __TR_Offset_correction (v: byte,u:int) begin
 0xB9, v, u
end

CompAction __TR_Default_correction (v: byte) begin
 0xBA, v
end


PrimAction	m1int(0x0001,0x10000001,sample_duration)		; Integration AD converter - Bit 0
PrimAction      m2temp(0x0002,0x10000002,10us)				; Thermoregulator - Bit 1


;Temperature regulation start
Action StartReg begin
 <0>=>__StartReg(1), extcomm
end

;Temperature regulation stop
Action StopReg begin
 <0>=>__StopReg, extcomm
end


;Set regulation temperature for TR2000
;parameter: 	- temperature in 1C (0-100)
Action SetTemp(Value) begin
  <0>=>__SetTemp(Value), extcomm
end



;Set parameters of rising mode for TR2000
;parameters: 	Value  - demanded regulation end temperature in 1C (-24 - 200)
;		Value2 - time for reaching the temperature in sec (65535)	
Action SetRisTemp(Value, Value2) begin
  <0>=>__SetRisTemp(Fit(-80,200,Value), Value2), extcomm
end


;Set Regulator constants
;parameters:    Value - Sum_term  
;		Value2 - Gain_term
Action SetRegulator(Value, Value2) begin
  <0>=>__SetRegulator(Value, Value2), extcomm
end
;


;Set Regulator constants
;parameters:    Value - Maximal Heating limit (10 - 100%)  
;(2,0x88,'B',Value)
Action SetHeatingLimit(Value) begin
  <0>=>__ChanI2C_2(2,136,66,Fit(10,100,Value)), extcomm
end


;Co ven poslat
;(2,0x88,'Z',0,10,Value)
;Value = 1.....CountOnTemp
; 	=2 ....ISuma
;	=3 ....DSuma
;	=4 ....bottom temperature
Action SetCoVen(Value) begin
  <0>=>__ChanI2C_4(2,136,90,0,0,Value), extcomm
end

;(kanal 2,0x88,'A',stav pumpy)
Action SetPump(Value) begin
  <0>=>__ChanI2C_2(2,136,65,Value), extcomm
end

;(kanal 2,0x88,'C',stav enable = 1 znamena povoleno pusteni dusiku a pritapeni)
Action ExtPowerEnable(Value) begin
  <0>=>__ChanI2C_2(2,136,67,Value), extcomm
end

;(kanal 2,0x88,'J',stav Ventilatoru na spodku TL)
;Action Vent(Value) begin
;  <0>=>__ChanI2C_2(2,136,74,Value), extcomm
;end

;(kanal 2,0x88,'J',stav chlazeni dusikem, teplota, na kterou chladit)
Action Nitro(Value,Temperature) begin
  Kelvin = Fit(-90,200,Temperature) + 273.0
  Value2 = (10.0*Kelvin)/256.0				;High byte
  <0>=>__ChanI2C_4(2,136,74,Value,10.0*Kelvin,Value2), extcomm
end

;(kanal 2,0x88,'G',stav ofukovani vzorku u TL)
Action SampleFan(Value) begin
  <0>=>__ChanI2C_2(2,136,71,Value), extcomm
end



Action Shutter_Off begin
   <0>=>__ChanI2C_1(1,64,128), extcomm
end

Action Shutter_On begin
   <0>=>__ChanI2C_1(1,64,0), extcomm
end

;Gain must be changed first, change always offset together with Gain
;Gain - Gain correction of TR2000 as multiplication factor of default
;Gain = (CAL50-CAL10)/(TR50-TR10)
;Offset - offset correction of TR2000 reading, in degC
;Offset=(KAL10-TR10)-TR10*(Gain-1)
Action TR_correction(Gain,Offset) begin
  <0s>=>__TR_Gain_correction(2,Fit(5000,30000,Gain*10000)), extcomm
  <1s>=>__TR_Offset_correction(2,Fit(-1000,1000,Offset*100)), extcomm
end

;default Gain and offset correction as Gain=1.0000 and Offset = 0.00
Action TR_Default_correction begin
  <0>=>__TR_Default_correction(2), extcomm
end


