;2005 PSI Ltd.
;Complicated Action definition file for using the digital oscillation module
;with the Fluorometer

;AD9852register numbers definitions - Register byte in SynCom_x command 
;PHASE1=0
;PHASE2=1
;FREQ1=2
;FREQ2=3
;DELTA_FREQ=4
;UPDATE=5
;RAMP=6
;CONTROL_REG=7
;MULTIPLIER=8
;SHAPE=10
;CONTROL_DAC=11

;CONSTANT_FREQ = 0
;SWEEP_FREQ = 4
;NO_FREQ = 64
;init_mode = -2


;[EXTCOMM]

;[EVENTS]
PrimAction	Osc_Update(0x4000,0x10004000,1us)   ; A7 trigger


;Primary Actions definitions
;*******************************************************************************

Action Set_Osc_Mode(Value) begin
  Val1 = 16
  Val2 = 36       
  Val3 = Value   
  Val4 = 32      
  <0>=>__SynCom_front_4(1,7,Val1,Val2,Val3,Val4), extcomm
 end

Action Set_Freq(Value) begin
;Value - frequence in Hz -float
   frekv = (Value*281474976710656.0/16000000.0)    ;FTW in AD9852
   Val6 = frekv/(65536.0*65536.0*256.0)          ;MSB  freq (bits 40-48)
   Val5 = frekv/(65536.0*65536.0)                ;freq (bits 39-32)
   Val4 = frekv/(65536.0*256.0)                  ;freq (bits 24-31)
   Val3 = frekv/65536.0                          ;freq (bits 16-23)
   Val2 = frekv/256.0                            ;freq (bits 8-15)
   Val1 = frekv                                  ;LSB  freq (bits 0-7)
  <0>=>__SynCom_front_6(1,2,Val6,Val5,Val4,Val3,Val2,Val1), extcomm
end

Action Set_Phase(Value) begin
;Value - phase in degrees -float 
   phase = Fit(0,16383,((Value*16384.0)/360.0))    ;PHASE in AD9852  (14 bits)
   Ph2 = phase/256.0                            ;MSB phase (bits 8-13)
   Ph1 = phase                                  ;LSB phase (bits 0-7)
  <0>=>__SynCom_front_2(1,0,Ph2,Ph1),extcomm
end

Action Set_Offset(Value) begin
;Value - offset in percents - 1 decimal place
  offset=4095-(20.47)*Fit(0,100,Value)

  Of2 =  offset/256.0                    ;MSB offset (bits 8-11)
  Of1 =  offset                         ;LSB offset (bits 0-7)
  <0>=>__SynCom_front_2(1,11,Of2,Of1), extcomm
end

Action Set_Amplitude(Value) begin
;Value - Amplitude in percents - float
  ampl = Fit(0,4095,(Value*40.95))
  Am2 =  ampl/256.0                    ;MSB offset (bits 8-11)
  Am1 =  ampl                          ;LSB offset (bits 0-7)
  <0>=>__SynCom_front_2(1,8,Am2,Am1), extcomm
end
 

Action Oscillation_ON begin
  <0>=>__Set_osc_light(1), extcomm
end

Action Oscillation_OFF begin
  <0>=>__Set_osc_light(0), extcomm
end

Action Sweep_up begin
  <0>=>__Set_sweep_dir(1), extcomm
end

Action Sweep_down begin
  <0>=>__Set_sweep_dir(0), extcomm
end

Action OSC(Amplitude,Offset,Frequency,Phase) begin
<-60ms>=>Set_Osc_Mode(64)
<-51ms>=>Osc_Update
<-50ms>=>Set_Osc_Mode(0),Set_Amplitude(Amplitude),Set_Phase(Phase),Set_Offset(Offset),Set_Freq(Frequency)
<0s>=>Osc_Update
end

Action OSC_OFF begin
<-50ms>=>Set_Osc_Mode(0),Set_Amplitude(0),Set_Phase(0),Set_Offset(0),Set_Freq(0)
<0s>=>Osc_Update
end


 
